﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinTabs;
using Infragistics.Win.UltraWinTabControl;
using System.Drawing;

namespace TabControlChangeSizeScrollButton
{
    class ChangeSizeScrollButtonFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            //Increasing scroll buttons area
            TabScrollButtonUIElement scrollsArea;
            TabHeaderAreaUIElement elementParent = parent as TabHeaderAreaUIElement;

            if (parent is TabHeaderAreaUIElement)
            {
                if (elementParent != null)
                {
                    scrollsArea = (TabScrollButtonUIElement)parent.GetDescendant(typeof(TabScrollButtonUIElement)) as TabScrollButtonUIElement;
                    if (scrollsArea != null)
                    {
                        scrollsArea.Rect = new Rectangle(scrollsArea.Rect.X-20, scrollsArea.Rect.Y-6 , scrollsArea.Rect.Width + 20, scrollsArea.Rect.Height + 8);
                        
                    }
                }
            }

            //Decreasing tab area
            TabRowUIElement tabsArea;

            if (parent is TabHeaderAreaUIElement)
            {
                if (elementParent != null)
                {
                    tabsArea = (TabRowUIElement)parent.GetDescendant(typeof(TabRowUIElement)) as TabRowUIElement;
                    if (tabsArea != null)
                    {
                        tabsArea.Rect = new Rectangle(tabsArea.Rect.X, tabsArea.Rect.Y, tabsArea.Rect.Width - 20, tabsArea.Rect.Height);                  
                    }
                }
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}